if(illustrator.version > 14 && scriptographer.version > 2.9){
			script.coordinateSystem = 'bottom-up';
}

var code;
var binCode;
var isbn;

var components = {
			num:{
						type: 'string',
						label: 'EAN-13',						
			},
			minLine:{
						type: 'number',
						label: 'Min. barwidth',
						min: 1,
						steppers: true,
						units: 'point'
			},
			gen:{
						type: 'button',
						value: 'Generate',
						onClick: function(){
									code = components.num.value;
									isbn = code;
									code = code.replace(/\D/g, '')
									if(code.length < 11){
												Dialog.alert('ERROR! Not enough digits.')
												return false;
									}
									if(code.length > 12){
												code = code.substring(0, 12)
									} else if(code.length == 11){
												code = '0' + code
									}
									code += EAN_checkSum(code)
									generateEAN()
									//components.num.value = code
									drawEAN()
						}
			}

}

var palette = new Palette('BarMaid', components)

function drawEAN(){
			x = 10
			y = 10
			for(i = 0; i < binCode.length; i++){
						if(parseInt(binCode.charAt(i)) == 1){
									if(i == 0 || i == 2 || i == 46 || i == 48 || i == 92 || i == 94){
												p = new Path.Rectangle(new Point(x, y), new Point(x + components.minLine.value, y + 58))
									} else {
												p = new Path.Rectangle(new Point(x, y), new Point(x + components.minLine.value, y + 50))
									}
						}
						x += components.minLine.value
			}
			// Put all paths into array
			var bars = document.getItems({type: Path});
			var allBars = bars[0];
			var tempBars;
			// Unite all paths in array into new path
			for(i = 1; i < bars.length; i++){
				tempBars = allBars.unite(bars[i]);
				allBars.remove();
				allBars = tempBars;
			}
			allBars.strokeColor = null;
			allBars.fillColor = new CMYKColor(0, 0, 0, 1);
			// Remove all paths in array
			for(i = 0; i < bars.length; i++){
				bars[i].remove();
			}
			
			var isbnPosition = new Point(7, y - 2);
			var isbnText = new PointText(isbnPosition);
			isbnText.content = "ISBN " + isbn;
			isbnText.characterStyle.font = app.fonts['Myriad Pro']['Regular'];
			isbnText.characterStyle.fontSize = 10;
			
			var pos1 = new Point(2, y + 60);
			var numText1 = new PointText(pos1);
			numText1.content = code.substring(0, 1);
			numText1.characterStyle.font = app.fonts['Myriad Pro']['Regular'];
			numText1.characterStyle.fontSize = 12;
			
			var pos2 = new Point(15, y + 60);
			var numText2 = new PointText(pos2);
			numText2.content = code.substring(1, 7);
			numText2.characterStyle.font = app.fonts['Myriad Pro']['Regular'];
			numText2.characterStyle.fontSize = 12;
			numText2.characterStyle.tracking = 50;
			
			var pos3 = new Point(61, y + 60);
			var numText3 = new PointText(pos3);
			numText3.content = code.substring(7, 13);
			numText3.characterStyle.font = app.fonts['Myriad Pro']['Regular'];
			numText3.characterStyle.fontSize = 12;
			numText3.characterStyle.tracking = 50;
}

function generateEAN(){			
			// Check first digit to 
			var parityTable = parity[parseInt(code.charAt(0))];
			// binCode is the string which holds the complete code. All EAN-13 start with 101
			binCode = '101'
			for(i = 1; i < code.length; i++){
						// What number in code?
						var num = parseInt(code.charAt(i));
						// Left or right of separator?
						if(i > 6){
									binCode += right[num]
						} else {
									// Odd or even?
									(parityTable[i - 1] % 2 == 0) ? binCode += even[num] : binCode += odd[num];
						}
						// Always a separator
						if(i == 6){binCode += '01010'}
			}
			// End of binary code
			binCode += '101'
}

function EAN_checkSum(code){
			var sum = 0;
			var digit = 0;
			for(var i = code.length; i >= 1; --i){
						digit = parseInt(code.substring(i - 1, i));
						(i % 2 == 0) ? sum += digit * 3 : sum += digit * 1
			}
			return (10 - (sum % 10)) % 10;
}

var parity =	[[1,1,1,1,1,1], [1,1,0,1,0,0], [1,1,0,0,1,0], [1,1,0,0,0,1], [1,0,1,1,0,0],
				[1,0,0,1,1,0], [1,0,0,0,1,1], [1,0,1,0,1,0], [1,0,1,0,0,1], [1,0,0,1,0,1]];

var odd =	['0001101', '0011001', '0010011', '0111101', '0100011',
			'0110001', '0101111', '0111011', '0110111', '0001011'];

var even =	['0100111', '0110011', '0011011', '0100001', '0011101',
			'0111001', '0000101', '0010001', '0001001', '0010111'];

var right =	['1110010', '1100110', '1101100', '1000010', '1011100',
			'1001110', '1010000', '1000100', '1001000', '1110100'];